<?php
require $_PROYDIR_STRIPE.'init.php';

\Stripe\Stripe::setApiKey($_STRIPE_PRIVATE_KEY);

header('Content-Type: application/json');

try {
    // retrieve JSON from POST body
    $jsonStr = file_get_contents('php://input');
    $jsonObj = json_decode($jsonStr);

    $setup = [
        'payment_method_options' => [
            'card' => [
                'request_three_d_secure' => 'any'
            ]
        ]
    ];
    $intent = \Stripe\SetupIntent::create($setup);
    
    $output = ['clientSecret' => $intent->client_secret, 'intent' => $intent];

    echo json_encode($output);
} catch (Error $e) {
    http_response_code(500);
    echo json_encode(['error' => $e->getMessage()]);
}