<?php
require $_PROYDIR_STRIPE.'init.php';

\Stripe\Stripe::setApiKey($_STRIPE_PRIVATE_KEY);
$stripe = new \Stripe\StripeClient($_STRIPE_PRIVATE_KEY);

header('Content-Type: application/json');

try {

    // retrieve JSON from POST body
    $jsonStr = file_get_contents('php://input');
    $jsonObj = json_decode($jsonStr);

    $datadir = $_SESSION['compra']['step1'];

    $customer = \Stripe\Customer::create([
        'payment_method' => $jsonObj->payment_method,
        'name'=> $datadir['nombre'],
        'email'=> $datadir['correo'],
        'phone'=> $datadir['telefono'],
    ]);

    $method = $stripe->paymentMethods->attach(
        $jsonObj->payment_method,
        ['customer' => $customer->id]
      );

    $data['client_secret'] = $jsonObj->client_secret;
    $data['customer_id'] = $customer->id;
    $data['payment_method'] = $jsonObj->payment_method;

    //pr($method->card);

    $card['brand'] = $method->card->brand;
    $card['country'] = $method->card->country;
    $card['exp_month'] = $method->card->exp_month;
    $card['exp_year'] = $method->card->exp_year;
    $card['funding'] = $method->card->funding;
    $card['last4'] = $method->card->last4;

    //prEx($card);

    $_SESSION['compra']['step2']['card'] = $card;
    $_SESSION['compra']['step2']['data_pay'] = $data;

    // retrieve JSON from POST body
    if($customer->id){
        $output = ['statusSave' => true];
        $_SESSION['compra']['step2']['step_status'] = true;
        $_SESSION['compra']['step2']['method_pay'] = $METODO['tarjeta'];
    }else{
        $output = ['statusSave' => false];
    }

    echo json_encode($output);
} catch (Error $e) {
    http_response_code(500);
    echo json_encode(['error' => $e->getMessage()]);
}