<?
class obj_ftpcon
{
  // private $ftp_connection;
    public $ftp_connection;

    public function __construct($host,$port,$user,$password)
    {
        try 
        {
            // Crear conexión FTP
            $this->ftp_connection = ftp_connect($host, $port);

            // Verificar si la conexión se realizó con éxito
            if (!$this->ftp_connection) 
            {
                COMLOGVISHTML("No se pudo conectar al servidor FTP: $host");
                return false;
            }

            // Iniciar sesión FTP
            $login_result = ftp_login($this->ftp_connection, $user, $password);

            // Verificar si el inicio de sesión fue exitoso
            if (!$login_result) 
            {
                COMLOGVISHTML("No se pudo iniciar sesión en el servidor FTP: $host");
                return false;
            }

        } 
        catch (Exception $e) 
        {
            COMLOGVISHTML('Error: ' . $e->getMessage());
        }
    }

public function crearDirectorio($directorio) 
{
    // Divide la ruta en componentes
    $directorios = explode('/', $directorio);
    $ruta_actual = '';  

    // Recorre cada directorio en la ruta
    foreach ($directorios as $directorio_actual) 
    {
        // Añade el directorio actual a la ruta acumulada
        $ruta_actual .= '/' . $directorio_actual;

        // Verifica si el directorio actual ya existe
        if (!ftp_chdir($this->ftp_connection, $ruta_actual)) 
        {
            // Intenta crear el directorio actual
            if (!ftp_mkdir($this->ftp_connection, $ruta_actual)) 
            {
                return false; // Error al crear el directorio
            }
        }
    }

    return true;  
}
    
    public function listaArchivosEnDirectorio($directorio)
    {
        // Obtener los archivos contenidos en el directorio actual
        if(!($archivos = ftp_nlist($this->ftp_connection, $directorio))){
            return false;
        }
        return $archivos;
    }

    public function existeArchivoEnDirectorio($directorio, $archivo) 
    {
        // Cambiar al directorio especificado
        if (!ftp_chdir($this->ftp_connection, $directorio)) 
        {
            return 0;
            //die("No se pudo cambiar al directorio: $directorio");
        }

        // Obtener la lista de archivos en el directorio
        $lista_archivos = ftp_nlist($this->ftp_connection, '.');

        // Verificar si la lista de archivos se pudo obtener
        if ($lista_archivos === false) 
        {
            //die("No se pudo obtener la lista de archivos en el directorio: $directorio");
            return 0;
        }

        // Verificar si el archivo existe en la lista de archivos
        foreach ($lista_archivos as $elemento) 
        {
            // Obtener el nombre del archivo
            $nombre_archivo = basename($elemento);

            if ($nombre_archivo === $archivo) 
            {
                return 1; // El archivo existe en el directorio
            }
        }

        // El archivo no se encontró en el directorio
        return 0;
    }

    public function colocarArchivoEnDirectorio($archivo_local, $directorio_remoto, &$msg="") 
    {
        // Verificar si el archivo local existe
        if (!file_exists($archivo_local)) 
        {
            $msg="El archivo local no existe: $archivo_local";
            return false;
        }

        // Obtener el nombre del archivo local
        $nombre_archivo = basename($archivo_local);

        // Verificar si el directorio remoto existe, si no, crearlo
        if (!$this->existeDirectorio($directorio_remoto)) 
        {
            if (!$this->crearDirectorio($directorio_remoto)) 
            {
                $msg="Error al crear el directorio remoto: $directorio_remoto";
                return false;
            }
        }

        // Cambiar al directorio remoto
        if (!ftp_chdir($this->ftp_connection, $directorio_remoto)) 
        {
            $msg="No se pudo cambiar al directorio remoto: $directorio_remoto";
            return false;
        }

        // Subir el archivo al directorio remoto
        if (!ftp_put($this->ftp_connection, $nombre_archivo, $archivo_local, FTP_BINARY)) 
        {
            $msg="Error al colocar el archivo en el directorio remoto";
            return false;
        }

        $msg="El archivo $nombre_archivo se ha colocado exitosamente en el directorio remoto $directorio_remoto";
        return true;
    }

    // Método para verificar la existencia de un directorio en la conexión FTP
    private function existeDirectorio($directorio) 
    {
        // Intentar cambiar al directorio especificado
        if (ftp_chdir($this->ftp_connection, $directorio)) 
        {
            return true; // El directorio existe
        } else 
        {
            return false; // El directorio no existe
        }
    }


 
}
?>