<?
include_once($_PROYDIR_OBJ."obj_ftpcon.php");

class obj_imagenes
{
	public $nombre;
	public $extencion;
	public $size;
	public $errores;
	public $tipo;
	public $imagenes;
	public $noImagenes;
	public $cantImgs;
	public $cantNoImage;
	public $cantImgsSaved;
	public $imgsSaved;
	public $cantImgsNoSaved;

	public $dirSave;
	public $dirFtp;
	public $dirFtpNoGrup;
	public $urlImages;
	public $dirDelete;
	public $dirSaveNoGrup;

	public $tamPrin = "400";
	public $tamMicro = "50";
	public $tamGal = "800";
	public $tamGalMin = "200";
	public $tamGalBig = "1200";
	public $version = 2;
	public $configured=false;

	private $oFtp=null;
	public $grupoId;

	function guardaImagenUrl($url,$nombre)
	{
		$directory = $this -> dirSave;

		return copy($url, $directory.$nombre.".jpg");
	}

	function getName($img)
	{
		return $img['name'];
	}

	function getTmpFile($img)
	{
		return $img['tmp_name'];
	}

	function getTypeImg($img,&$ext)
	{
		$ext = ($img['type'] == "image/png")? ".png":".jpg";
		return $img['type'];
	}

	function actualizaImagen($numImg)
	{
		$directory = $this -> dirSave;
		$tmp_image = $this -> getTmpFile($this -> imagenes[0]);

		$img_replace = $directory."img_".$numImg.".jpg";

		$imgUp = move_uploaded_file($tmp_image,$img_replace);

		if($imgUp)
		{
			$files     = glob($directory."img_{,[1-9]}[0-9].jpg", GLOB_BRACE);
			$listaImgs = $this -> ordenaArchivos($files,"img_");
			
			$this -> imgsSaved = $listaImgs;


			$this -> generaImgPrin();

			$this -> generaImgMicro();

			$this -> generaImgGal();

			$this -> generaImgGalBig();

			$this -> generaImgGalMin();
		}

		return $imgUp;
	}

	function eliminaImagenesComponente($prefix)
	{
		$imagesDir = $this -> dirSave;

		if(!$imagesDir)
			die("undefined directory");

		if(!$prefix)
			die("undefined componente prefix");

		$files = glob($imagesDir.$prefix."*.jpg", GLOB_BRACE);

		foreach ($files as $im ){
			unlink($im);
		}
	}

	function oredenaImgs($nom,$disp,$pos)
	{
		$imagesDir = $this -> dirSave;

		if(!$imagesDir)
			die("undefined directory");

		if(!$nom)
			die("undefined image name");

		$im = $imagesDir.$nom.".jpg";

		$x = explode("_",$nom);

		$prefix = $x[0]."_".$x[1]."_";
		$numImg = $x[2];

		$files = glob($imagesDir.$prefix."*.jpg", GLOB_BRACE);

		$listaImgs = $this -> ordenaArchivosV2($files,$prefix);

		$baseOrg = $imagesDir."org_".$prefix;
		$b_nom = "_".$x[3].".jpg";

		$ix = ($pos)? 0:1;
 
		for ($i=$disp; $i >= ($numImg+$ix); $i--)
		{
			if(file_exists($listaImgs[$i]))
			{
				rename($listaImgs[$i],$imagesDir.$prefix.($i+1).$b_nom);
				rename($baseOrg.($i).$b_nom,$baseOrg.($i+1).$b_nom);
			}
		}
		
		return 1;
	}

	function elimina($nom)
	{
		$imagesDir = $this -> dirSave;

		if(!$imagesDir)
			die("undefined directory");

		if(!$nom)
			die("undefined image name");

		$im = $imagesDir.$nom.".jpg";

		return unlink($im);
	}

	function eliminaImagen($nom,$disp)
	{
		$imagesDir = $this -> dirSave;

		if(!$imagesDir)
			die("undefined directory");

		if(!$nom)
			die("undefined image name");

		$im = $imagesDir.$nom.".jpg";

		$x = explode("_",$nom);

		$prefix = $x[0]."_".$x[1]."_";
		$numImg = $x[2];

		$files = glob($imagesDir.$prefix."*.jpg", GLOB_BRACE);

		$listaImgs = $this -> ordenaArchivosV2($files,$prefix);

		$original = $imagesDir."org_".end(explode("/", $listaImgs[$numImg]));

		unlink($listaImgs[$numImg]);
		unlink($original);

		$baseOrg = $imagesDir."org_".$prefix;
		$b_nom = "_".$x[3].".jpg";

		for ($i=$numImg; $i < $disp; $i++)
		{
			if(file_exists($listaImgs[$i+1]))
			{
				rename($listaImgs[$i+1],$imagesDir.$prefix.($i).$b_nom);
				rename($baseOrg.($i+1).$b_nom,$baseOrg.($i).$b_nom);
			}
		}
		

		return 1;
	}

	function ordenaArchivosV2($arrFiles,$prefix)
	{
		foreach ($arrFiles as $img)
		{
			$i = explode(".jpg", explode($prefix, $img)[1])[0];
			$aux[explode("_",$i)[0]] = $img;
		}

		ksort($aux);

		return $aux;
	}

	function eliminaImagenN($numImg)
	{
		$imagesDir = $this -> dirSave;

		$images = array("originales" => "img_",
						"galprin" 	 => "img_gal",
						"galmin" 	 => "img_galmin",
						"galbig" 	 => "img_galbig");

		foreach ($images  as $nomvar => $prefix)
		{
			$files = glob($imagesDir.$prefix."{,[1-9]}[0-9].jpg", GLOB_BRACE);

			$listaImgs = $this -> ordenaArchivos($files,$prefix);

			if($nomvar == "originales")
			{
				$this -> imgsSaved = $listaImgs;
				$this -> cantImgs = count($listaImgs)-1;
			}

			unlink($listaImgs[$numImg]);

			for ($i=$numImg; $i < count($listaImgs); $i++)
				rename($listaImgs[$i+1],$imagesDir.$prefix.($i).".jpg");
		}

		if($numImg == 0)
		{
			$this -> generaImgPrin();
			$this -> generaImgMicro();
		}
	}

	function ordenaArchivos($arrFiles,$prefix)
	{
		foreach ($arrFiles as $i => $img)
			$aux[explode(".jpg", explode($prefix, $img)[1])[0]] = $img;

		ksort($aux);

		return $aux;
	}

	function generateCustomImage($nombre,$w=0,$h=0,$fondo="")
	{
		$imagen = $this -> imgsSaved[0];
		$dir = $this -> dirSave;

		$width  = $w;
		$height = $h;

		if(!$w || !$h)
			list($width,$height) = getimagesize($imagen);

		if($fondo)
			GuardarImagenV3CenterCut($imagen,$dir,$nombre.".jpg",$width,$height,$fondo);
		else
			GuardarImagenV4CenterCut($imagen,$dir,$nombre.".jpg",$width,$height,1);
	}

	function generaImgPrin($nombre='')
	{
		$imagen = $this -> imgsSaved[0];
		$dir = $this -> dirSave;

		$width = $height = $this -> tamPrin;

		if(!$nombre)
			$nombre = "img_prin";
		
			$nombre.=".jpg";

		$version = $this -> version;

		if($version == 2)
			GuardarImagenV3CenterCut($imagen,$dir,$nombre,$width,$height,0);

		if($version == 1)
			GuardarImagenV4CenterCut($imagen,$dir,$nombre,$width,$height,1);
	}

	function generaImgMicro($nombre='')
	{
		$imagen = $this -> imgsSaved[0];
		$dir = $this -> dirSave;

		$width = $height = $this -> tamMicro;

		if(!$nombre)
			$nombre = "img_micro";

		$nombre.=".jpg";

		$version = $this -> version;

		if($version == 2)
			GuardarImagenV3CenterCut($imagen,$dir,$nombre,$width,$height,0);

		if($version == 1)
			GuardarImagenV4CenterCut($imagen,$dir,$nombre,$width,$height,1);
	}

	function generaImgGalBig()
	{
		$imagenes = $this -> imgsSaved;
		$dir = $this -> dirSave;

		$width = $height = $this -> tamGalBig;

		$version = $this -> version;

		if($version == 2)
		{
			foreach ($imagenes as $n => $imagen)
				GuardarImagenV3CenterCut($imagen,$dir,"img_galbig$n.jpg",$width,$height,0);
		}

		if($version == 1)
		{
			foreach ($imagenes as $n => $imagen)
				GuardarImagenV4CenterCut($imagen,$dir,"img_galbig$n.jpg",$width,$height,1);
		}	
	}

	function generaCustomImg()
	{
		$imagenes = $this -> imgsSaved;
		$dir = $this -> dirSave;

		$width = $height = $this -> tamGalBig;
		
		foreach ($imagenes as $n => $imagen)
			GuardarImagenV4CenterCut($imagen,$dir,"img_galbig$n.jpg",$width,$height,1);
	}

	function generaImgGal($idPag,$idGal,$its)
	{
		$imagenes = $this -> imgsSaved;
		$dir = $this -> dirSave;

		$width = $height = $this -> tamGal;

		$version = $this -> version;

		//Se debe consultar Si se usa imagenes o its para el foreach

		if($version == 2)
		{
			foreach ($imagenes as $n => $imagen)
				GuardarImagenV3CenterCut($imagen,$dir,"galeria_".$idGal."_".$its[$n]."_pag".$idPag.".jpg",$width,$height,0);
		}

		if($version == 1)
		{
			foreach ($imagenes as $n => $imagen)
				GuardarImagenV4CenterCut($imagen,$dir,"galeria_".$idGal."_".$its[$n]."_pag".$idPag.".jpg",$width,$height,1);
		}	
	}

	function generaImgGalMin()
	{
		$imagenes = $this -> imgsSaved;

		//$this -> cantImgs

		$dir = $this -> dirSave;

		$width = $height = $this -> tamGalMin;

		$version = $this -> version;

		if($version == 2)
		{
			foreach ($imagenes as $n => $imagen)
				GuardarImagenV3CenterCut($imagen,$dir,"img_galmin$n.jpg",$width,$height,0);
		}

		if($version == 1)
		{
			foreach ($imagenes as $n => $imagen)
				GuardarImagenV4CenterCut($imagen,$dir,"img_galmin$n.jpg",$width,$height,1);
		}	
	}

	function getWidthHeightImage($imagen,$tam,&$width,&$height)
	{
		list($width, $height) = getimagesize($imagen);

		if($width >= $height)
		{
			$base = "width";
			$base2 = "height";
			$aux = $width;
		}

		if($width <= $height)
		{
			$base = "height";
			$base2 = "width";
			$aux = $height;
		}

		${$base} = $tam;

		${$base2} = ceil((100*${$base2}/$aux)*${$base}*(.01));
	}

	function ordenaImagenes()
	{
		$imagenes = $this -> imagenes;

		for($i = 0; $i < count($imagenes['tmp_name']); $i++)
		{
			foreach ($imagenes as $key => $data)
				$imgsord[$i][$key] = $data[$i];
		}

		$imgsok = [];
		$noimg = [];

		foreach ($imgsord as $img)
		{
			if($this -> validaImagen($img))
				$imgsok[] = $img;
			else
				$noimg[]  = $img;
		}

		$this -> cantNoImage = count($noimg);
		$this -> noImagenes = $noimg;

		$this -> cantImgs   = count($imgsok);
		$this -> imagenes = $imgsok;
	}

	function validaImagen($img)
	{	
		$t = $img['type'];
		$valido = ["image/jpeg","image/png"];

		return in_array($t,$valido);
	}

	function guardaImagenes($numset='',$contertToPng=true)
	{
		$_DIR = $this->dirSave;
		
		$imgs_no_mov = [];
		$imgs_saved = [];

		if(!file_exists($_DIR)) {
			mkdir($_DIR,0777,true);
		}

		if(!file_exists($_DIR)) {
			$errores['DIR'] = "No se pudo crear el directorio ** $_DIR **";
		} else {
			$num = 1;
			if($numset){
				$num = $numset;
			}
			
			foreach ($this->imagenes as $img)
			{
				$tmp_image = $this->getTmpFile($img);

				$this->getTypeImg($img,$ext);

				$imagen  = $_DIR.$num.$ext;
				$img_name = $_DIR.$num.".jpg";

				if(!move_uploaded_file($tmp_image,$imagen)) {
					$imgs_no_mov[] = $this->getName($img);
				} else {
					if($ext == ".png" && $contertToPng)
					{
						$pngImage = imagecreatefrompng($imagen);
														    
					    imagejpeg($pngImage, $img_name, "100");
					    imagedestroy($pngImage);

					    if(file_exists($img_name)) {
					    	unlink($imagen);
					    }

					    $imagen = $img_name;
					}

					$num++;
					$imgs_saved[] = $imagen;
				}
			}

			if(isset($imgs_no_mov))
				$errores['MOV'] = $imgs_no_mov;
		}
		
		$this -> errores = $errores;

		$this -> cantImgsNoSaved = count($imgs_no_mov);
		$this -> cantImgsSaved   = count($imgs_saved);

		$this -> imgsSaved = $imgs_saved;
	}

	public function saveEmbedYtVideo($content, &$name)
	{
		if(!$name){
			$name = "yt.txt";
		}

		if(!($content = trim($content))){
			return false;
		}

		if(!file_exists($this->dirSave)){
			mkdir($this->dirSave,0777,true);
		}

		if(!file_exists($this->dirSave)){
			return false;
		}

		$yt_file=$this->dirSave.$name;

		
		$fileLink = fopen($yt_file, "w");
		fwrite($fileLink,$content);
		fclose($fileLink);

		return file_exists($yt_file);
	}

	public function configuraDirectorioArchivos($IDPROD,$COLOR,$NGRUP="")
	{
		GLOBAL $_DIR_IMGS_360, $_URL_IMGS_360, $DIR_IMG_TEMP, $_DIR_IMGS_360_FTP;

		//Grupo donde estaran las imagenes
		$grupo="/";
		$GRUPDIR="";
		if($NGRUP != ""){
			$grupo.= "grup".$NGRUP."/";
			$GRUPDIR = "grup".$NGRUP.DIRECTORY_SEPARATOR;
		}

		$FOLDER_DESTINO="temporal/".$COLOR;
		$DIR_DESTINO=$COLOR.DIRECTORY_SEPARATOR;

		//Directorio temporarl por si el color del producto no tiene IdProd
		$DIR_IMG_SAVE = $DIR_IMG_TEMP;

		if($IDPROD)
		{
			$idfolder = datadirv2($IDPROD);
			$FOLDER_DESTINO=$idfolder.$COLOR;

			$iddir = datadirv2($IDPROD,DIRECTORY_SEPARATOR);
			$DIR_DESTINO = $iddir.$DIR_DESTINO;

			$DIR_IMG_SAVE = $_DIR_IMGS_360;
		}

		//url de archivos para visualizacion
		$this->urlImages = $_URL_IMGS_360.$FOLDER_DESTINO.$grupo;

		//folder para colocar archivos ftp
		if($this->oFtp->ftp_connection){
			$this->dirFtp = $_DIR_IMGS_360_FTP.$FOLDER_DESTINO.$grupo;
			$this->dirFtpNoGrup = $_DIR_IMGS_360_FTP.$FOLDER_DESTINO;
		}

		//directorio de en donde se guardan los archivos y el mismo de donde se toman para subirlos por ftp
		$DIR_IMG_SAVE.= $DIR_DESTINO;

		$this->dirSaveNoGrup=$DIR_IMG_SAVE;
		$this->dirSave=$DIR_IMG_SAVE.$GRUPDIR;
		$this->grupoId=$NGRUP;
		$this->configured=true;
	}

	public function eliminaImagenesGrupo()
	{
		if(!$this->configured){
			die("Error: debe configuraDirectorioArchivos()");
		}

		$imagenes_eliminar = glob($this->dirSave."{{,[1-9]}[0-9].{jpg,png,PNG},yt.txt}", GLOB_BRACE);

		foreach ($imagenes_eliminar as $imgdel) {
			unlink($imgdel);
		}
	}

	public function eliminaImagenesGrupoFtp()
	{
		if(!$this->configured){
			die("Error: debe configuraDirectorioArchivos()");
		}

		if(!$this->oFtp->ftp_connection){
			COMLOGVISHTML("NO SE PUDO ELIMINAR IMAGENES ERROR FTP");
			return false;
		}
		$archivosFtp=$this->oFtp->listaArchivosEnDirectorio($this->dirFtp);
		//Se descuenta 2 por los directorios ['.', '..']
		$cantEndirectorio=count($archivosFtp)-2;

		$eliminados=0;
		foreach ($archivosFtp as $archivoFtp) {
			if(!str_ends_with($archivoFtp, '.')){
				$eliminados+= ftp_delete($this->oFtp->ftp_connection, $archivoFtp);
			}
		}

		//Si se eliminaron todos los archivos se elimina el folder del grupo
		if($cantEndirectorio == $eliminados){
			ftp_rmdir($this->oFtp->ftp_connection, $this->dirFtp);
		}

		return $eliminados;
	}

	public function creaConeccionFtp()
	{
		GLOBAL $_FTP_DOMIAN,$_FTP_PORT,$_FTP_USER,$_FTP_PASS;
		$this->oFtp = new obj_ftpcon($_FTP_DOMIAN,$_FTP_PORT,$_FTP_USER,$_FTP_PASS);

		if(!$this->oFtp->ftp_connection){
			COMLOGVISHTML("NO SE PUDO CONECTAR FTP");
			return false;
		}
	}

	public function guardaImagenEnFtp($img, $dir)
	{
		if(!$this->oFtp->ftp_connection){
			COMLOGVISHTML("NO SE PUDO GUARDAR IMAGENES ERROR FTP");
			return false;
		}

		return $this->oFtp->colocarArchivoEnDirectorio($img,$dir);	
	}

	private function creaArregloImagenes($producto,$anilloDiamante=false)
	{
		if(!$producto['idProd'] || !$producto['color']){
			return false;
		}

		if(!$this->oFtp->ftp_connection){
			COMLOGVISHTML("NO SE PUDO CARGAR IMAGENES ERROR FTP");
			return false;
		}

		$this->configuraDirectorioArchivos($producto['idProd'],$producto['color']);

		$dirs=$this->oFtp->listaArchivosEnDirectorio($this->dirFtp);
		// pr($dirs);

		$gdirs=[];
		foreach($dirs as $gdir){
			$lastchar=substr($gdir, -1);
			// a(anillo) d(diamante) OR images 360 o video YT
			if($anilloDiamante && in_array($lastchar, ['a','d'])){
				$gdirs[$lastchar]=$gdir;
			}

			if(!$anilloDiamante && is_numeric($lastchar)){
				$gdirs[$lastchar]=$gdir;
			}
		}

		// pr($gdirs);

		$imagenes=[];
		foreach($gdirs as $g => $dir){
			$archivos=$this->oFtp->listaArchivosEnDirectorio($dir);
			// echo "consultando: $dir\n";
			// pr($archivos);
			foreach($archivos as $ar){
				$end=end(explode(".", $ar));
				if(in_array($end, ['jpg','png','txt'])){
					$imagenes[$g][]=$ar;
				}
			}
		}
		// echo "\n\n\n\n";

		return $imagenes;
	}

	public function cargaImagenesAnilloDiamanteFtp($producto,$getpair=false)
	{
		if(!($imagenes=$this->creaArregloImagenes($producto,true))){
			return false;
		}
		// pr($imagenes);

        $an_diam = [];
        foreach($imagenes as $grupo => $image){
            $an_diam[$grupo] = $this->urlImages."grup$grupo/";
        }
        // pr($an_diam);

        if($getpair && count($an_diam) != 2){
            return false;
        }

        return $an_diam;
	}

	public function cargaImagenesFtpProducto($producto)
	{
		if(!($imagenes=$this->creaArregloImagenes($producto))){
			return false;
		}

		$max = 0;
        $index_max=0;
        $index = 0;
		
		foreach($imagenes as $grupo => $imgs){

            $l_imgs=[];
            $lista_imgs=[];

            $BASEGRP=$this->urlImages."grup$grupo/";
            $img_prin = $BASEGRP."1.jpg";

            foreach ($imgs as $img) {
                $img_nom = end(explode("/", $img));
                $urlimg = $BASEGRP.$img_nom;

                if($img_nom=="yt.txt"){
                    $img_prin = file_get_contents($BASEGRP.$img_nom);
                }

                $l_imgs[] = $urlimg;
            }

            $cant_imgs = count($l_imgs);

            if($cant_imgs>$max && $cant_imgs>1){
                $max = $cant_imgs;
                $index_max = $index;
            }

            $lista_imgs['cant'] = $cant_imgs;
            $lista_imgs['urls'] = $l_imgs;
            $lista_imgs['img_prin'] = $img_prin;
            $lista_imgs['url_base'] = $BASEGRP;

            $lista_grup[$index] = $lista_imgs;
            $index++;
		}

		$aux = $lista_grup[0];
        $lista_grup[0] = $lista_grup[$index_max];
        $lista_grup[$index_max] = $aux;

        return $lista_grup?$lista_grup:0;
	}

	//Al eliminar un grupo de imagenes este se tiene que ordenar 0->n
	public function ordenaImagenesGrupo($DIR="")
	{
		if(!$DIR){
			$DIR=$this->dirSaveNoGrup;
		}

		if(!$DIR){
			return false;
		}

		$DIRS_GRUPS = glob($DIR."grup{{,[1-9]}[0-9]}",GLOB_BRACE);
		sort($DIRS_GRUPS);

		$ngrup = 0;
		$arr_info_grupo=[];
		foreach ($DIRS_GRUPS as $i => $grupo) {
			$lista_imgs = glob($grupo.DIRECTORY_SEPARATOR."{{,[1-9]}[0-9].jpg,yt.txt}", GLOB_BRACE);

			$base_dir = substr($grupo, 0,-1);
			$numimgs = count($lista_imgs);

			if(!$numimgs) {
				rmdir($grupo);
			} else {
				rename($grupo,$base_dir.$ngrup);

				$es_360 = $numimgs>1?1:0;
				$info_grupo = $ngrup.":".$numimgs.":".$es_360;
				$arr_info_grupo[] = $info_grupo;
				$ngrup++;
			}
		}

		return $arr_info_grupo;
	}

	public function ordenaImagenesGrupoFtp()
	{
		if(!$this->configured){
			die("Error: debe configuraDirectorioArchivos()");
		}

		if(!$this->oFtp->ftp_connection){
			COMLOGVISHTML("NO SE PUDO ORDENAR IMAGENES ERROR FTP");
			return false;
		}

		$dirbase=$this->dirFtpNoGrup."/";
		$gruposImgs=$this->oFtp->listaArchivosEnDirectorio($dirbase);
		sort($gruposImgs);
			
		$grupos=[];
		foreach ($gruposImgs as $key => $gimg) {
			$lastchar=substr($gimg, -1);
			//Solo grupos numericos
			if(!in_array($lastchar, ['.','a','d'])){
				$grupos[]=$gimg;
			}
		}

		$ng=0;
		foreach ($grupos as $grupo) {
			ftp_rename($this->oFtp->ftp_connection, $grupo, $dirbase."grup$ng");
			$ng++;
		}
	}

	public function guardaImagenesProducto($idProd,$color)
	{	
		if(!$idProd || !$color)
			return 0;

		//Direcorio donde se guardaran
		$this->configuraDirectorioArchivos($idProd,$color);
		$DIR_IMGS_DESTINO=$this->dirSaveNoGrup;
		$DIR_IMGS_DESTINO_FTP=$this->dirFtpNoGrup;

		//Directorio donde se encuentran las imagenes ahora
		$this->configuraDirectorioArchivos(0,$color);
		$DIR_IMGS_ORIGEN=$this->dirSaveNoGrup;
		$DIR_IMGS_ORIGEN_FTP=$this->dirFtpNoGrup;

		if(!($grupos_origen = glob($DIR_IMGS_ORIGEN."grup*"))){
			return 0;
		}

		$width = $height = 800;

		foreach ($grupos_origen as $gorg) {
			$grupo=substr($gorg, -1);
			$grupdir="grup".$grupo.DIRECTORY_SEPARATOR;

			$DIR_GRUP_ORG = $DIR_IMGS_DESTINO.$grupdir;
			$FTP_GRUPO_DESTINO = $DIR_IMGS_DESTINO_FTP."/grup$grupo/";
			$FTP_GRUPO_ORIGEN = $DIR_IMGS_ORIGEN_FTP."/grup$grupo/";

			if(!file_exists($DIR_GRUP_ORG)){
				mkdir($DIR_GRUP_ORG,0777,true);
			}

			$TEMP_IMGS_GRUP = $DIR_IMGS_ORIGEN.$grupdir;
			//Archivos del grupo
			$ARCHIVOS_EN_GRUPO = glob($TEMP_IMGS_GRUP."{{,[1-9]}[0-9].{jpg,png,PNG},yt.txt}", GLOB_BRACE);

			if($ARCHIVOS_EN_GRUPO){

				$IMGS_BY_GRUP = $this->ordenaArchivos($ARCHIVOS_EN_GRUPO,$TEMP_IMGS_GRUP);
				$IMGS_BY_GRUP = array_values($IMGS_BY_GRUP);

				foreach ($IMGS_BY_GRUP as $n => $imagen) {

					$fname=end(explode(DIRECTORY_SEPARATOR, $imagen));
					$imagen_guardar_ftp="";
					
					//imagenes anillo diamante o video youtube
					if(in_array($grupo, ['a','d']) || $fname == "yt.txt"){
						// echo "rename($imagen, $DIR_GRUP_ORG$fname);";
						$imagen_guardar_ftp = $DIR_GRUP_ORG.$fname;
						rename($imagen, $DIR_GRUP_ORG.$fname);
					}else if(is_numeric($grupo)){
						  // echo "GuardarImagenV4CenterCut($imagen,$DIR_GRUP_ORG".($n+1)."jpg";
						$imagen_guardar_ftp = $DIR_GRUP_ORG.($n+1).".jpg";
						GuardarImagenV4CenterCut($imagen,$DIR_GRUP_ORG,($n+1).".jpg",$width,$height,1);	
					}

					if($this->oFtp){

						// echo "guardaImagenEnFtp($imagen_guardar_ftp,$FTP_GRUPO_DESTINO);\n";
						// echo "ftp_delete(1, $FTP_GRUPO_ORIGEN$fname)\n\n";

						$this->guardaImagenEnFtp($imagen_guardar_ftp,$FTP_GRUPO_DESTINO);
						ftp_delete($this->oFtp->ftp_connection, $FTP_GRUPO_ORIGEN.$fname);
					}
					
					if(file_exists($imagen)){
						unlink($imagen);
					}
				}
			}
			rmdir($TEMP_IMGS_GRUP);
		}
		// die("***");
	}


	public function __construct($images="",$widthFtpConnection=false)
	{
		if($images)
		{
			$this->imagenes = $images;
		}

		if($widthFtpConnection){
			$this->creaConeccionFtp();
		}
	}
}
?>