<?PHP

require_once($_PROYDIR_CONEKTA."lib".DIRECTORY_SEPARATOR."Conekta.php");

class obj_payment{

    private $apiVersion = "2.0.0";

    public function __construct($apiKey, $token){

    	  $this -> apiKey = $apiKey; 
        $this -> token  = $token;
        $this -> erroresVal = null;
        $this -> error = null;
        $this -> errorGen = null;
        $this -> oClie = null;
        $this -> monthly_installments=null;
        $this -> concepto = "Pago";
        $this -> total_anticipo = 0;
        $this -> anticipo_resto = null;
        $this -> ult_idOper = 0;
    }

    public function setDataCard($card,$tarjetahabiente){
    	  $this -> card  = $card;
        $this -> tarjetahabiente = $tarjetahabiente;
    }

    public function setData($name,$phone,$email,$description,$total,$total_base){

        $this -> name  = $name;
        $this -> phone = $phone;
        $this -> email = $email;
        $this -> description=$description;
        $this -> total = $total;
        $this -> total_base = $total_base;

        $this -> carrito = $_SESSION['carrito'];
    }

    public function pay(){

        \Conekta\Conekta::setApiKey($this->apiKey);
        \Conekta\Conekta::setApiVersion($this->apiVersion);

        // echo "**1**";
        if(!$this->Validate())
            return false;

        // echo "**2**";

        if(!$this->CreateCustomer())
            return false;

        // echo "**3**";

        if(!$this->CreateOrder())
            return false;

        $this->Save();

        $this->iniciaBalance();

        $this->saveDirPed();

        return true;
    }

    public function payCustom(){

        \Conekta\Conekta::setApiKey($this->apiKey);
        \Conekta\Conekta::setApiVersion($this->apiVersion);

        // echo "**1**";
        if(!$this->Validate())
            return false;

        // echo "**2**";

        if(!$this->CreateCustomer())
            return false;

        // echo "**3**";

          echo "------v2.4------";

        if(!$this->CreateOrder())
            return false;

        if($this->es_pago_apertura){
            $this->updatePedido();
        }else{
            $this->order_number = $this->idPedido;
        }

        $this->updateOperation($this->idOperacion);

        if($this->es_pago_apertura || $this->monthly_installments!=null){
            $this->continuaBalance();
        }

        return true;
    }

    public function payOneOperation($idOperacion){

        \Conekta\Conekta::setApiKey($this->apiKey);
        \Conekta\Conekta::setApiVersion($this->apiVersion);

        // echo "**1**";
        if(!$this->Validate())
            return false;

        // echo "**2**";

        if(!$this->CreateCustomer())
            return false;

        // echo "**3**";

        if(!$this->CreateOrder())
            return false;

        return $this->updateOperation($idOperacion);
    }

    public function updateOperation($idOperacion) {

      GLOBAL $METODO;

      $data['tipo'] = 1;
      $data['estatus'] = $this->order->payment_status;

      // if($this->es_pago_personalizado || $this->es_pago_apertura){
      //   $data['estatus'] = "";
      // }

      if($this->es_pago_apertura){
        $data['estatus'] = "";
      }


      $metodo = "Transferencia interbancaria";
      if($this->payment_method == $METODO['tarjeta']) {
        $tp['credit'] = "Tarjeta de crédito";
        $tp['debit'] = "Tarjeta de débito";

        $metodo = $tp[$this->order->charges[0]->payment_method->type];
      }

      if($this->es_pago_apertura){
        $metodo="";
      }

      //es una operacion a pagar y es por medio de meses sin intereses de deshabilita el pago asignado y se considera el pago con intereses de msi
      if(!$this->es_pago_apertura && $this->es_pago_personalizado && $this->monthly_installments!=null){
        $data['estatus_matrimony'] = 0;
      }

      $data['metodo'] = $metodo;
      $data['order_id'] = $this->order->id;

      $up = $this->oClie->actualizaBalanceOperacionIdOper($idOperacion,$data,$created_at);

      $this->created_at=$created_at;

      return $up;
    }

    public function Save() {

      GLOBAL $Link,$METODO;

        $params = [
            'usuario_creo'=> $this->email,
            'correo'=> $this->email,
            'nombre'=> $this->name,
            'telefono' => $this->phone*1,
            'total' => $this->total*1,
            'total_anticipo' => $this->total_anticipo*1,
            'total_base' => $this->total_base*1,
            'descripcion_pago' => $this->description,
            'ses_carrito' => json_encode($this->carrito),
            'cantidad_productos' => count($this->carrito),
            'order_id'=>$this->order->id,
            'payment_code'=>$this -> order->charges[0]->payment_method->auth_code,
            'estatus_pago' => $this->order->payment_status
        ];

        if($this->payment_method == $METODO['tarjeta']) {

          $tipo_pago = "tarjeta";

          $xpar = substr($this->card,strlen($this->card)-5,4);
          $cryp_card = encryptIt($this->card,$xpar);

          $paramsExtra = [
            'tarjeta'=> $xpar,
            'brand' => $this->order->charges[0]->payment_method->brand,
            'rand' => $cryp_card,
            // 'tarjetahabiente' => utf8_decode($this->tarjetahabiente),
            'tarjetahabiente' => $this->tarjetahabiente,
            'tipo'  => $this->order->charges[0]->payment_method->type,
            'msi' => ($this->monthly_installments!=null)*1
          ];


        }else {

          $tipo_pago = "transferencia";

          $paramsExtra = [
            'clabe_receptora'=> $this->order->charges[0]->payment_method->clabe,
            'expires_at'  => $this->order->charges[0]->payment_method->expires_at,
          ];
        }

        $params = array_merge($params,$paramsExtra);
        $params['tipo_pago'] = $tipo_pago;

        setCamposIns($params);

        //Se salva el pedido
        $resIns = insertReg($Link,"reg_payment",$params,$xres);
        COMLOG("REGISTRO VENTA: function Save(): ".print_r($xres,true));

        $this->order_number = $xres['LII'];
        $this->created_at = $params['_fechaIns'];
    }

    public function updatePedido() {

      GLOBAL $Link,$METODO;

        $params = [
            'total' => $this->total,
            'total_anticipo' => $this->total_anticipo,
            'total_base' => $this->total_base,
            'descripcion_pago' => $this->description,
            'ses_carrito' => json_encode($this->carrito),
            'cantidad_productos' => count($this->carrito),
            'order_id'=>$this->order->id,
            'payment_code'=>$this -> order->charges[0]->payment_method->auth_code,
            'estatus_pago' => $this->order->payment_status
        ];

        if($this->payment_method == $METODO['tarjeta']) {

          $tipo_pago = "tarjeta";

          $xpar = substr($this->card,strlen($this->card)-5,4);
          $cryp_card = encryptIt($this->card,$xpar);

          $paramsExtra = [
            'tarjeta'=> $xpar,
            'brand' => $this->order->charges[0]->payment_method->brand,
            'rand' => $cryp_card,
            // 'tarjetahabiente' => utf8_decode($this->tarjetahabiente),
            'tarjetahabiente' => $this->tarjetahabiente,
            'tipo'  => $this->order->charges[0]->payment_method->type,
            'msi' => ($this->monthly_installments!=null)
          ];


        }else {

          $tipo_pago = "transferencia";

          $paramsExtra = [
            'clabe_receptora'=> $this->order->charges[0]->payment_method->clabe,
            'expires_at'  => $this->order->charges[0]->payment_method->expires_at,
          ];
        }

        $params = array_merge($params,$paramsExtra);
        $params['tipo_pago'] = $tipo_pago;

        setCamposAct($params);
        //Actualizar el pedido
        $where = "idReg = '".$this->idPedido."'";
        $campos = implode(",", array_keys($params));

        //echo "$where - $campos \n";
        //prEx($params);
        updateReg($Link,"reg_payment",$where,$params,$campos,$xres);
        COMLOG("REGISTRO VENTA: function updatePedido(): ".print_r($xres,true));

        $this->order_number = $this->idPedido;
        $this->created_at = $params['_fechaAct'];
    }

    public function saveDirPed(){
      if($this->oClie!=null)
      {
        $data = $_SESSION['compra']['step1'];
        COMLOG("REGISTRO VENTA: function saveDirPed(): ".print_r($data,true));
        $data['order_id'] = $this->order->id;
        $idDir = $this->oClie->guardaDireccionPedido($this->order_number,$data,$unactive);
      }
    }

    private function iniciaBalance(){

      GLOBAL $Link,$METODO;

      $es_anticipo = (strtolower($this->concepto)=="anticipo");

      //Apertura
      $b1['idPedido'] = $this->order_number;
      $b1['concepto'] = "Apertura";

      //Tipo balance desde sistema
      $b1['tipo'] = 1;
      $b1['signo'] = -1;
      $b1['cliente'] = $this->email;
      $b1['importe'] = $this->total_base;

      //Segundo concepto
      $b2['idPedido'] = $this->order_number;
      $b2['concepto'] = $this->concepto;
      //Tipo balance desde sistema
      $b2['tipo'] = 1;

      //ver que pasa cuando no se coloca el esttus
      // $b2['estatus'] = $this->order->payment_status;
      $b2['estatus'] = "pending_payment";
      $b2['signo'] = 1;
      $b2['order_id'] = $this->order->id;
      $b2['cliente'] = $this->email;
      $b2['importe'] = $this->total;

      if($this->payment_method == $METODO['tarjeta']){

        $tp['credit'] = "Tarjeta de crédito";
        $tp['debit'] = "Tarjeta de débito";

        $b2['metodo'] = $tp[$this->order->charges[0]->payment_method->type];

        if($this->monthly_installments!=null){

          $b3['idPedido'] = $this->order_number;
          $b3['concepto'] = "Cargo MSI";
          //Tipo balance desde sistema
          $b3['tipo'] = 1;
          $b3['signo'] = -1;
          $b3['cliente'] = $this->email;
          $b3['importe'] = ($this->total-$this->total_base);

          if($es_anticipo){
            $b3['importe'] = ($this->total-$this->total_anticipo);
          }

        }
        //End tipo tarjeta
      }
      else{
        $b2['metodo'] = "Transferencia bancaria";
      }

      //Si es un anticipo se debe de generar otr concepto
      if($es_anticipo && $this->anticipo_resto!=null){
        //cuarto concepto
        $b4['idPedido'] = $this->order_number;
        $b4['concepto'] = "Resto del anticipo";
        //Tipo balance "como si fuera manual"
        $b4['tipo'] = 2;
        $b4['estatus'] = "pending_payment";
        $b4['signo'] = 1;
        // $b4['order_id'] = "";
        $b4['cliente']  = $this->email;
        $b4['importe']  = $this->anticipo_resto;
        $b4['metodo']   = "";
      }

      $balance[] = $b1;
      $balance[] = $b2;

      if(isset($b3)){
        $balance[] = $b3;
      }

      if(isset($b4)){
        $balance[] = $b4;
      }

      foreach($balance as $i => $b){
        setCamposIns($b);
        insertReg($Link,"balance_operaciones",$b,$xres);
        COMLOG("REGISTRO VENTA: function iniciaBalance(): ".print_r($xres,true));

        $ult_idOper = $xres['LII'];
      }

      $this->ult_idOper = $ult_idOper;
    }

    private function continuaBalance(){

      GLOBAL $Link,$METODO;

      $es_anticipo = (strtolower($this->concepto)=="anticipo");

      //Segundo concepto
      $b2['idPedido'] = $this->order_number;
      $b2['concepto'] = $this->concepto;
      //Tipo balance desde sistema
      $b2['tipo'] = 1;

      //ver que pasa cuando no se coloca el esttus
      // $b2['estatus'] = $this->order->payment_status;
      $b2['estatus'] = "pending_payment";
      $b2['signo'] = 1;
      $b2['order_id'] = $this->order->id;
      $b2['cliente'] = $this->email;
      $b2['importe'] = $this->total;

      if($this->payment_method == $METODO['tarjeta']){

        $tp['credit'] = "Tarjeta de crédito";
        $tp['debit'] = "Tarjeta de débito";

        $b2['metodo'] = $tp[$this->order->charges[0]->payment_method->type];

        if($this->monthly_installments!=null){

          $b3['idPedido'] = $this->order_number;
          $b3['concepto'] = "Cargo MSI";
          //Tipo balance desde sistema
          $b3['tipo'] = 1;
          $b3['signo'] = -1;
          $b3['cliente'] = $this->email;
          $b3['importe'] = ($this->total-$this->total_base);

          if($es_anticipo){
            $b3['importe'] = ($this->total-$this->total_anticipo);
          }

        }
        //End tipo tarjeta
      }
      else{
        $b2['metodo'] = "Transferencia bancaria";
      }

      //Si es un anticipo se debe de generar otr concepto
      if($es_anticipo && $this->anticipo_resto!=null){
        //cuarto concepto
        $b4['idPedido'] = $this->order_number;
        $b4['concepto'] = "Resto del anticipo";
        //Tipo balance "como si fuera manual"
        $b4['tipo'] = 2;
        $b4['estatus'] = "pending_payment";
        $b4['signo'] = 1;
        // $b4['order_id'] = "";
        $b4['cliente']  = $this->email;
        $b4['importe']  = $this->anticipo_resto;
        $b4['metodo']   = "";
      }

      $balance[] = $b2;

      if(isset($b3)){
        $balance[] = $b3;
      }

      if(isset($b4)){
        $balance[] = $b4;
      }

      foreach($balance as $i => $b){
        setCamposIns($b);
        insertReg($Link,"balance_operaciones",$b,$xres);
        COMLOG("REGISTRO VENTA: function continuaBalance(): ".print_r($xres,true));

        $ult_idOper = $xres['LII'];
      }

      $this->ult_idOper = $ult_idOper;
    }

  public function CreateOrder(){
    GLOBAL $METODO;
  try{

    //pr($this->carrito); 

    // foreach($this->carrito as $i => $producto){
    //   $line_items['line_items'][] = [
    //             'name'        => $producto['nombre'],
    //             'description' => $producto['descripcion'],
    //             'unit_price'  => $producto['contado']*100,
    //             'quantity'    => 1,
    //             'sku'         => $producto['sku'],
    //             // 'category'    => 'food',
    //             // 'tags'        => ['food', 'mexican food']
    //         ];
    // }

    // $valid_order =
    // [
    //     $line_items,
    //     // 'currency' => 'mxn',
    //     // 'metadata' => ['test' => 'extra info'],
    //     'charges'  => [
    //         [
    //             'payment_method' => [
    //                 'type'       => 'oxxo_cash',
    //                 'expires_at' => strtotime(date("Y-m-d H:i:s")) + "36000"
    //             ],
    //             'amount' => $this->total*100,
    //         ]
    //     ],
    //     'currency' => 'MXN',
    //     'customer_info' => [
    //       "customer_id" => $this->customer->id 
    //         // 'name'  => 'John Constantine',
    //         // 'phone' => '+5213353319758',
    //         // 'email' => 'hola@hola.com',
    //     ]
    // ];
    // pr($valid_order);

      $payment_method['payment_method']["type"] = "default";

      if($this->payment_method == $METODO['transferencia']){
        $thirty_days_from_now = (new DateTime())->add(new DateInterval('P30D'))->getTimestamp(); 

        $payment_method['payment_method']["type"] = "spei";
        $payment_method['payment_method']["expires_at"] = $thirty_days_from_now;
      }else if($this->monthly_installments!=null){
        $payment_method['payment_method']["monthly_installments"] = $this->monthly_installments;
      }
      
    
      $order = array(
          "amount"=>$this->total,
          "line_items" => array(
            array(
              "name" => $this->description,
              "unit_price" => $this->total*100, //se multiplica por 100 conekta
              "quantity" => 1,
            )//first line_item
          ), //line_items
          "currency" => "MXN",
          "customer_info" => array(
          "customer_id" => $this->customer->id 
          ), //customer_info
          "charges" => array(
              $payment_method //first charge
          ) //charges
          // "charges" => array(
          //     array(
          //         "payment_method" => array(
          //           "type"=>"default",
          //          // "type" => "card",
          //          // "token_id" => "tok_test_visa_4242"
          //          // "token_id" => "".$this->token
          //         ) 
          //     ) //first charge
          // ) //charges
        );//order
        //pr($order);
      
      $this->order = \Conekta\Order::create($order);

    } catch (\Conekta\ProcessingError $error){
      $this->error=$error->getMessage();
      return false;
    } catch (\Conekta\ParameterValidationError $error){
      $this->error=$error->getMessage();
      return false;
    } catch (\Conekta\Handler $error){
      $this->error=$error->getMessage();
      return false;
    }

    return true;
}

     
    public function CreateOrder2()
    {
    	try{
		  $order = \Conekta\Order::create(
		    [
		      "line_items" => [
		        [
		          "name" => $this->description,
		          "unit_price" => $this->total*100,
		          "quantity" => 1
		        ]
		      ],
		      // "shipping_lines" => [
		      //   [
		      //     "amount" => 1500,
		      //     "carrier" => "FEDEX"
		      //   ]
		      // ], //optional - shipping_lines are only required for physical goods
		      "currency" => "MXN",
		      "customer_info" => [
		        "name" => $this->name,
		        "email" => $this->email,
		        "phone" => "7774913086"
		      ],
		      "shipping_contact" => [
		        "address" => [
		          "street1" => "Calle fulano",
		          "postal_code" => "62790",
		          "country" => "MX"
		        ]
		      ], //optional - shipping_contact is only required for physical goods
		      // "metadata" => ["reference" => "12987324097", "more_info" => "lalalalala"],
		      "charges" => [
		        [
		          "payment_method" => [
		            // "monthly_installments" => 3, //optional
		            "type" => "card",
		            // "token_id" => $this -> token
		            "token_id" => "tok_test_visa_4242"
		          ] //payment_method - use customer's default - a card
		            //to charge a card, different from the default,
		            //you can indicate the card's source_id as shown in the Retry Card Section
		        ]
		      ]
		    ]
		  );
		} catch (\Conekta\ProcessingError $error){
		  echo $error->getMessage();
		} catch (\Conekta\ParameterValidationError $error){
		  echo $error->getMessage();
		} catch (\Conekta\Handler $error){
			pr($error);
		  echo $error->getMessage();
		}
    }
    

    public function CreateCustomer(){
      GLOBAL $METODO;
        try {

          $name = preg_replace('/[0-9]+/', '', $this->name);
          $name = preg_replace("/[^a-zA-Záéíóó\s]/", "", $name);
          // $aux = "";

          // foreach(str_split($name) as $l){
          //   if(ctype_alpha($l) || $l==" ")
          //     $aux.=$l;
          // }
        

          //die("$name----");

          //Customer CARD
          $customer = array(
            "name"  => $name,
            "email" => $this->email,
            // "phone" => $this->phone,
            "payment_sources" => array(
              array(
                  "type" => "card",
                  "token_id" => $this->token
              )
            )//payment_sources
          );//customer

          //Customer TRANSFER
          if($this->payment_method == $METODO['transferencia']) { 
            $customer = array(
              "name"  => $this->name,
              "email" => $this->email,
              // "phone" => $this->phone,
            );//customer
          }

          $this->customer = \Conekta\Customer::create($customer);

        } catch (\Conekta\ProccessingError $error){
          $this->error=$error->getMesage();
          return false;
        } catch (\Conekta\ParameterValidationError $error){
          $this->error=$error->getMessage();
          return false;
        } catch (\Conekta\Handler $error){
        	//pr($error);
          $this->error=$error->getMessage();
          return false;
        }
  
        return true;
    }

    public function Validate(){

      GLOBAL $METODO;

        if(!$this->name){
        	$this -> erroresVal[] = "El nombre es obligatorio.";
        }

        if($this->payment_method == $METODO['tarjeta'])
        {
            if(!$this->card){
              $this->erroresVal[] = "El número de tarjeta es obligatorio.";
            }
           
            if(strlen($this->card)<=14){
              $this->erroresVal[] = "El número de tarjeta debe tener al menos 15 caracteres.";
            }
        }

        if(!filter_var($this->email, FILTER_VALIDATE_EMAIL)){
          $this->erroresVal[] = "El correo electrónico no tiene un formato de correo válido.";
        }

        if($this->total<=20){
          $this->erroresVal[] = "El monto debe ser mayor a 20 pesos.";
        }

        if($this->erroresVal!=null){
        	//$this->errorGen = "Errores de validación.";
        	return false;
        }
  
        return true;
      }
}

?>