<?PHP
require $_PROYDIR_STRIPE.'init.php';

class obj_stripe{

    public function __construct($apiKey,$customer='',$payment_method=''){

        $this -> apiKey = $apiKey; 
        $this -> customer=$customer;
        $this -> payment_method = $payment_method;

        $this -> erroresVal = null;
        $this -> error = null;
        $this -> errorGen = null;
        $this -> oClie = null;
        $this -> monthly_installments=null;
        $this -> concepto = "Pago";
        $this -> total_anticipo = 0;
        $this -> anticipo_resto = null;
        $this -> ult_idOper = 0;
    }

    public function setData($name,$phone,$email,$description,$total,$total_base){
        $this -> name  = $name;
        $this -> phone = $phone;
        $this -> email = $email;
        $this -> description=$description;
        $this -> total = $total;
        $this -> total_base = $total_base;

        $this -> carrito = $_SESSION['carrito'];
    }

    public function retrivePaymentIntent($paymentIntent)
    {
      try {
        $stripe = new \Stripe\StripeClient($this->apiKey);
        $this->order = $stripe->paymentIntents->retrieve($paymentIntent);
      } catch (Error $e) {
          $error = $e->getMessage();
          //die("$error --");
          COMLOG("ERROR RETRIVE PAYMENTINTENT: ".print_r($error,true));
      }
    }

    public function pay(){
        \Stripe\Stripe::setApiKey($this->apiKey);

        COMLOG("ANTES DE paymentIntent()");
        if($_SESSION['SESUS_login']){
          if(!$this->paymentIntentV2()){
            return false;
          }else{
            COMLOG("No hizo paymentIntent()");
          }
        }else{
          if(!$this->paymentIntent()){
            return false;
          }else{
            COMLOG("No hizo paymentIntent()");
          }
        }

        COMLOG("ANTES DE Save()");
        $this->Save();

        COMLOG("ANTES DE iniciaBalance()");
        $this->iniciaBalance();


        COMLOG("ANTES DE saveDirPed()");
        $this->saveDirPed();

        return true;
    }

    public function payCustom(){
        \Stripe\Stripe::setApiKey($this->apiKey);

        if(!$this->paymentIntent())
          return false;

        $this->order_number = $this->idPedido;

        if($this->es_pago_apertura){
            $this->updatePedido();
        }

        $this->updateOperation($this->idOperacion);

        if($this->es_pago_apertura || $this->monthly_installments!=null){
          $this->continuaBalance();
        }

        return true;
    }

    public function paymentIntent(){
        try {
            $datadir = $_SESSION['compra']['step1'];

            $dataIntent = [
                'amount' => $this->total*100,
                'currency' => 'mxn',
                'payment_method_types' => ['card'],
                'description' => $this->description,
                'shipping' => [
                    'name' => $this->name,
                    'address' => [
                      'city'=>$datadir['ciudad'],
                      'postal_code'=>$datadir['cp'],
                    ],
                    'phone' => $this->phone*1,
                  ],
                'customer' => $this->customer,
                'payment_method' => $this->payment_method,
                'off_session' => true,
                'confirm' => true,
              ];

            COMLOG("dataIntent PAYMENT v1: ".print_r($dataIntent,true));

            $intent = \Stripe\PaymentIntent::create($dataIntent);
        
            $this->order = $intent;

            return true;

        } catch (Exception $e) {
            //http_response_code(500);
            $this->error = $e->getMessage();
            COMLOG("ERROR PAYMENT: function paymentIntent(): ".print_r($this->error,true));
            //echo json_encode(['error' => $e->getMessage()]);
            return false;
        }
    }

    public function paymentIntentV2(){
        try {
            $datadir = $_SESSION['compra']['step1'];

            $intent = \Stripe\PaymentIntent::create([
                'amount' => $this->total*100,
                'currency' => 'mxn',
                'payment_method_types' => ['card'],
                // 'payment_method_options' => [
                //     'card' => [
                //         'request_three_d_secure' => 'any'
                //     ]
                // ],
                'description' => $this->description,
                'shipping' => [
                    'name' => $this->name,
                    'address' => [
                      'city'=>$datadir['ciudad'],
                      'postal_code'=>$datadir['cp'],
                    ],
                    'phone' => $this->phone*1,
                  ],
                'customer' => $this->customer,
                'payment_method' => $this->payment_method,
                'off_session' => true,
                // 'off_session' => false,
                // 'confirmation_method' => 'manual',
                'confirm' => true,
              ]);
        
              $this->order = $intent;
              return true;

        } catch (Error $e) {
            //http_response_code(500);
            $this->error = $e->getMessage();
            COMLOG("ERROR PAYMENT: function paymentIntentV2(): ".print_r($this->error,true));
            //echo json_encode(['error' => $e->getMessage()]);
            return false;
        }
    }

    public function payOneOperation($idOperacion){

        \Conekta\Conekta::setApiKey($this->apiKey);
        \Conekta\Conekta::setApiVersion($this->apiVersion);

        // echo "**1**";
        if(!$this->Validate())
            return false;

        // echo "**2**";

        if(!$this->CreateCustomer())
            return false;

        // echo "**3**";

        if(!$this->CreateOrder())
            return false;

        return $this->updateOperation($idOperacion);
    }

    public function updateOperation($idOperacion) {

      GLOBAL $METODO;

      $tp['credit'] = "Tarjeta de crédito";
      $tp['debit'] = "Tarjeta de débito";

      $status = $this->order->status === 'succeeded' ? 'paid' : 'pending_payment';
      $metodo = $tp[$this->payment_method_details->card->funding];

      $data['tipo'] = 1;
      $data['estatus'] = "pending_payment";//$status;
      $data['metodo'] = $metodo;

      if($this->es_pago_apertura){
        $data['estatus'] = "";
        $data['metodo'] = "";
      }

      $data['order_id'] = $this->order->id;

      $up = $this->oClie->actualizaBalanceOperacionIdOper($idOperacion,$data,$created_at);
      COMLOG("function updateOperation() v1: ". print_r($this->oClie->_oDat->ultRes,true));

      $this->created_at=$created_at;

      return $up;
    }

    public function Save() {
        GLOBAL $Link,$METODO;

        $status = $this->order->status === 'succeeded' ? 'paid' : 'pending_payment';

        $params = [
            'pasarela_pago' => "stripe",
            'correo'=> $this->email,
            'nombre'=> $this->name,
            'telefono' => $this->phone*1,
            'total' => $this->total*1,
            'total_anticipo' => $this->total_anticipo*1,
            'total_base' => $this->total_base*1,
            'descripcion_pago' => $this->description,
            'ses_carrito' => json_encode($this->carrito),
            'cantidad_productos' => count($this->carrito),
            'order_id'=>$this->order->id,
            // 'payment_code'=>$this -> order->charges[0]->payment_method->auth_code,
            'estatus_pago' => $status,
            'estatus_pago_stripe' => $this->order->status
        ];

        //if($this->payment_method == $METODO['tarjeta']) {

          $tipo_pago = "tarjeta";

          $details = $this->order->charges->data[0]->payment_method_details;
          $this->payment_method_details = $details;

          $paramsExtra = [
            'tarjeta'=> $details->card->last4,
            'brand' => $details->card->brand,
            'rand' => "",
            'tarjetahabiente' => $this->tarjetahabiente,
            'tipo'  => $details->type,
            'msi' => ($this->monthly_installments!=null)*1
          ];

          $this->card_details = $paramsExtra;


        //}

        $params = array_merge($params,$paramsExtra);
        $params['tipo_pago'] = $tipo_pago;

        setCamposIns($params);
        //Se salva el pedido
        $resIns = insertReg($Link,"reg_payment",$params,$xres);
        COMLOG("REGISTRO VENTA: function Save(): ".print_r($xres,true));

        $this->order_number = $xres['LII'];
        $this->created_at = $params['_fechaIns'];
    }

    public function updatePedido() {

      GLOBAL $Link,$METODO;

        $status = $this->order->status === 'succeeded' ? 'paid' : 'pending_payment';
        $params = [
            'total' => $this->total,
            'total_anticipo' => $this->total_anticipo,
            'total_base' => $this->total_base,
            'descripcion_pago' => $this->description,
            // 'ses_carrito' => json_encode($this->carrito),
            // 'cantidad_productos' => count($this->carrito),
            'order_id'=>$this->order->id,
            // 'payment_code'=>$this -> order->charges[0]->payment_method->auth_code,
            'estatus_pago' => $status,
            'estatus_pago_stripe' => $this->order->status
        ];

        

        $tipo_pago = "tarjeta";
        $details = $this->order->charges->data[0]->payment_method_details;
        $this->payment_method_details = $details;

        //$xpar = substr($this->card,strlen($this->card)-5,4);
        //$cryp_card = encryptIt($this->card,$xpar);

        $paramsExtra = [
            'tarjeta'=> $details->card->last4,
            'brand' => $details->card->brand,
            'rand' => "",
            'tarjetahabiente' => $this->tarjetahabiente,
            'tipo'  => $details->type,
            'msi' => ($this->monthly_installments!=null)*1
          ];

        $params = array_merge($params,$paramsExtra);
        $params['tipo_pago'] = $tipo_pago;

        setCamposAct($params);
        //Actualizar el pedido
        $where = "idReg = '".$this->idPedido."'";
        $campos = implode(",", array_keys($params));

        //echo "$where - $campos \n";
        //prEx($params);
        updateReg($Link,"reg_payment",$where,$params,$campos,$xres);
        COMLOG("REGISTRO VENTA: function updatePedido(): ".print_r($xres,true));
        $this->created_at = $params['_fechaAct'];
    }

    public function saveDirPed(){
      if($this->oClie!=null)
      {
        $data = $_SESSION['compra']['step1'];
        COMLOG("REGISTRO VENTA: function saveDirPed(): ".print_r($data,true));
        $data['order_id'] = $this->order->id;
        $idDir = $this->oClie->guardaDireccionPedido($this->order_number,$data,$unactive);
      }
    }

    public function iniciaBalance(){

      GLOBAL $Link,$METODO;

      $es_anticipo = (strtolower($this->concepto)=="anticipo");

      //Apertura
      $b1['idPedido'] = $this->order_number;
      $b1['concepto'] = "Apertura";

      //Tipo balance desde sistema
      $b1['tipo'] = 1;
      $b1['signo'] = -1;
      $b1['cliente'] = $this->email;
      $b1['importe'] = $this->total_base;

      //Segundo concepto
      $b2['idPedido'] = $this->order_number;
      $b2['concepto'] = $this->concepto;
      //Tipo balance desde sistema
      $b2['tipo'] = 1;

      //ver que pasa cuando no se coloca el esttus
      // $b2['estatus'] = $this->order->payment_status;
      $b2['estatus'] = "pending_payment";
      $b2['signo'] = 1;
      $b2['order_id'] = $this->order->id;
      $b2['cliente'] = $this->email;
      $b2['importe'] = $this->total;

    //   if($this->payment_method == $METODO['tarjeta']){
    if(true){
        $tp['credit'] = "Tarjeta de crédito";
        $tp['debit'] = "Tarjeta de débito";

        $b2['metodo'] = $tp[$this->payment_method_details->card->funding];

        if($this->monthly_installments!=null){

          $b3['idPedido'] = $this->order_number;
          $b3['concepto'] = "Cargo MSI";
          //Tipo balance desde sistema
          $b3['tipo'] = 1;
          $b3['signo'] = -1;
          $b3['cliente'] = $this->email;
          $b3['importe'] = ($this->total-$this->total_base);

          if($es_anticipo){
            $b3['importe'] = ($this->total-$this->total_anticipo);
          }

        }
        //End tipo tarjeta
      }
    //   else{
    //     $b2['metodo'] = "Transferencia bancaria";
    //   }

      //Si es un anticipo se debe de generar otr concepto
      if($es_anticipo && $this->anticipo_resto!=null){
        //cuarto concepto
        $b4['idPedido'] = $this->order_number;
        $b4['concepto'] = "Resto del anticipo";
        //Tipo balance "como si fuera manual"
        $b4['tipo'] = 2;
        $b4['estatus'] = "pending_payment";
        $b4['signo'] = 1;
        // $b4['order_id'] = "";
        $b4['cliente']  = $this->email;
        $b4['importe']  = $this->anticipo_resto;
        $b4['metodo']   = "";
      }

      $balance[] = $b1;
      $balance[] = $b2;

      if(isset($b3)){
        $balance[] = $b3;
      }

      if(isset($b4)){
        $balance[] = $b4;
      }

      foreach($balance as $i => $b){
        setCamposIns($b);
        insertReg($Link,"balance_operaciones",$b,$xres);
        COMLOG("REGISTRO VENTA: function iniciaBalance(): ".print_r($xres,true));

        $ult_idOper = $xres['LII'];
      }

      $this->ult_idOper = $ult_idOper;
    }

    public function continuaBalance(){

      GLOBAL $Link,$METODO;

      $es_anticipo = (strtolower($this->concepto)=="anticipo");

      //Segundo concepto
      $b2['idPedido'] = $this->order_number;
      $b2['concepto'] = $this->concepto;
      //Tipo balance desde sistema
      $b2['tipo'] = 1;

      //ver que pasa cuando no se coloca el esttus
      // $b2['estatus'] = $this->order->payment_status;
      $b2['estatus'] = "pending_payment";
      $b2['signo'] = 1;
      $b2['order_id'] = $this->order->id;
      $b2['cliente'] = $this->email;
      $b2['importe'] = $this->total;

      $tp['credit'] = "Tarjeta de crédito";
      $tp['debit'] = "Tarjeta de débito";

      $b2['metodo'] = $tp[$this->payment_method_details->card->funding];

      // if($this->monthly_installments!=null){

      //   $b3['idPedido'] = $this->order_number;
      //   $b3['concepto'] = "Cargo MSI";
      //   //Tipo balance desde sistema
      //   $b3['tipo'] = 1;
      //   $b3['signo'] = -1;
      //   $b3['cliente'] = $this->email;
      //   $b3['importe'] = ($this->total-$this->total_base);

      //   if($es_anticipo){
      //     $b3['importe'] = ($this->total-$this->total_anticipo);
      //   }

      // }

      //Si es un anticipo se debe de generar otr concepto
      if($es_anticipo && $this->anticipo_resto!=null){
        //cuarto concepto
        $b4['idPedido'] = $this->order_number;
        $b4['concepto'] = "Resto del anticipo";
        //Tipo balance "como si fuera manual"
        $b4['tipo'] = 2;
        $b4['estatus'] = "pending_payment";
        $b4['signo'] = 1;
        // $b4['order_id'] = "";
        $b4['cliente']  = $this->email;
        $b4['importe']  = $this->anticipo_resto;
        $b4['metodo']   = "";
      }

      $balance[] = $b2;

      if(isset($b3)){
        $balance[] = $b3;
      }

      if(isset($b4)){
        $balance[] = $b4;
      }

      foreach($balance as $i => $b){
        setCamposIns($b);
        insertReg($Link,"balance_operaciones",$b,$xres);
        COMLOG("REGISTRO VENTA: function continuaBalance(): ".print_r($xres,true));

        $ult_idOper = $xres['LII'];
      }

      $this->ult_idOper = $ult_idOper;
    }

  public function CreateOrder(){
    GLOBAL $METODO;
  try{
      $payment_method['payment_method']["type"] = "default";

      if($this->payment_method == $METODO['transferencia']){
        $thirty_days_from_now = (new DateTime())->add(new DateInterval('P30D'))->getTimestamp(); 

        $payment_method['payment_method']["type"] = "spei";
        $payment_method['payment_method']["expires_at"] = $thirty_days_from_now;
      }else if($this->monthly_installments!=null){
        $payment_method['payment_method']["monthly_installments"] = $this->monthly_installments;
      }
      
    
      $order = array(
          "amount"=>$this->total,
          "line_items" => array(
            array(
              "name" => $this->description,
              "unit_price" => $this->total*100, //se multiplica por 100 conekta
              "quantity" => 1,
            )//first line_item
          ), //line_items
          "currency" => "MXN",
          "customer_info" => array(
          "customer_id" => $this->customer->id 
          ), //customer_info
          "charges" => array(
              $payment_method //first charge
          ) //charges
          // "charges" => array(
          //     array(
          //         "payment_method" => array(
          //           "type"=>"default",
          //          // "type" => "card",
          //          // "token_id" => "tok_test_visa_4242"
          //          // "token_id" => "".$this->token
          //         ) 
          //     ) //first charge
          // ) //charges
        );//order
        //pr($order);
      
      $this->order = \Conekta\Order::create($order);

    } catch (\Conekta\ProcessingError $error){
      $this->error=$error->getMessage();
      return false;
    } catch (\Conekta\ParameterValidationError $error){
      $this->error=$error->getMessage();
      return false;
    } catch (\Conekta\Handler $error){
      $this->error=$error->getMessage();
      return false;
    }

    return true;
}

    

    public function CreateCustomer(){
      GLOBAL $METODO;
        try {

          $name = preg_replace('/[0-9]+/', '', $this->name);
          $name = preg_replace("/[^a-zA-Záéíóó\s]/", "", $name);
          // $aux = "";

          // foreach(str_split($name) as $l){
          //   if(ctype_alpha($l) || $l==" ")
          //     $aux.=$l;
          // }
        

          //die("$name----");

          //Customer CARD
          $customer = array(
            "name"  => $name,
            "email" => $this->email,
            // "phone" => $this->phone,
            "payment_sources" => array(
              array(
                  "type" => "card",
                  "token_id" => $this->token
              )
            )//payment_sources
          );//customer

          //Customer TRANSFER
          if($this->payment_method == $METODO['transferencia']) { 
            $customer = array(
              "name"  => $this->name,
              "email" => $this->email,
              // "phone" => $this->phone,
            );//customer
          }

          $this->customer = \Conekta\Customer::create($customer);

        } catch (\Conekta\ProccessingError $error){
          $this->error=$error->getMesage();
          return false;
        } catch (\Conekta\ParameterValidationError $error){
          $this->error=$error->getMessage();
          return false;
        } catch (\Conekta\Handler $error){
        	//pr($error);
          $this->error=$error->getMessage();
          return false;
        }
  
        return true;
    }

    public function Validate(){

      GLOBAL $METODO;

        if(!$this->name){
        	$this -> erroresVal[] = "El nombre es obligatorio.";
        }

        if($this->payment_method == $METODO['tarjeta'])
        {
            if(!$this->card){
              $this->erroresVal[] = "El número de tarjeta es obligatorio.";
            }
           
            if(strlen($this->card)<=14){
              $this->erroresVal[] = "El número de tarjeta debe tener al menos 15 caracteres.";
            }
        }

        if(!filter_var($this->email, FILTER_VALIDATE_EMAIL)){
          $this->erroresVal[] = "El correo electrónico no tiene un formato de correo válido.";
        }

        if($this->total<=20){
          $this->erroresVal[] = "El monto debe ser mayor a 20 pesos.";
        }

        if($this->erroresVal!=null){
        	//$this->errorGen = "Errores de validación.";
        	return false;
        }
  
        return true;
      }
}

?>