<style type="text/css">
	.canvasjs-chart-credit{
		display: none !important;
	}
	.datepicker{
		  background-color: transparent !important;
		  padding: 0 5px 0 0;
		  font-size: 23px;
	}

	.barra_graph{
		height: 5px;
		border-radius: 10px;
		min-width: 10%;
		box-shadow: 1px 1px 2px rgba(0,0,0,0.5);
	}
	.ingresos .barra_graph,.barra_graph_ingresos{
		background-color: #60AAFF;
	}

	.gastos .barra_graph,.barra_graph_gastos{
		background-color: #F60D4F;
	}
	.ingresos .gasto_ingreso{
		color: #60AAFF;
	}

	.gastos .gasto_ingreso{
		color: #F60D4F;
	}

	.barra_graph_ingresos,.barra_graph_gastos{
		min-height: 10%;
		width: 100%;
		display: flex;
		justify-content: center;
		align-items: center;
	}

</style>
<main class="main-content v2">
	<div class="container rapp-container mb-5">

		<div class="row">
			<div class="col">
				<h4><a href="<?= $_URLBASE; ?>acsis-inicio.html" class="text-dark">Inicio</a> > <a href="<?= $_URLBASE; ?>acsis-dashboard.html" class="text-dark">Dashboard</a></h4>
			</div>
		</div>

		<div class="row mb-4">
			<? foreach ($detalles_pedidos as $key => $detalle) { ?>
			<div class="col-lg-3 col-sm-6 pt-3">
				<div class="card border-0">
					<div class="p-2 text-dark">
						<h6 class="mb-0"><b><?= $detalle['titulo']; ?></b></h6>
						<div class="fs22"><?= $detalle['valor']; ?></div>
						<small><?= $detalle['subvalor'] ?></small>
					</div>
				</div>
			</div>
			<? } ?>
		</div>

		<div class="row">
			<div class="col">
				<div class="card border-0 text-dark mb-5">

					<div class="d-flex p-3 align-items-center">

						<input id="FECHA1" type="text" class="datepicker" value="<?= $F_FECHA1; ?>">
						<i class="fa fa-caret-down" aria-hidden="true"></i>

						<b class="mx-3 fs24">-</b>

						<input id="FECHA2" type="text" class="datepicker" value="<?= $F_FECHA2; ?>">
						<i class="fa fa-caret-down" aria-hidden="true"></i>
					</div>

					<div class="px-3">
						<div class="row">
							<? foreach ($detalles_graph as $key => $detalle) { ?>
							<div class="col">
								<div class="card border-0">
									<div class="p-2 text-dark">
										<h6 class="mb-0"><b><?= $detalle['titulo']; ?></b></h6>
										<div class="fs20"><?= $detalle['valor']; ?></div>
									</div>
								</div>
							</div>
							<? } ?>
						</div>

						<div class="mb-4">
							<div id="chartContainer" class="w-100" style="height: 370px;"></div>
						</div>

						<div class="row">
							<? foreach($datos_gasto_ingreso as $tipo =>$datos){ ?>
								<div class="col-md-3 <?= $tipo; ?>">
								<?  $i=0; 
									foreach ($datos as $label => $gasto_ingreso) {
										$porcentage=(100*$gasto_ingreso)/${"total_$tipo"};
										if(!$i){
											$max_porcentage=$porcentage;
										}
										$width=number_format((100*$porcentage)/$max_porcentage,2);
								?>
										<div class="data">
											<h6><b><?= $label; ?></b></h6>
											<div style="width:<?= $width; ?>%" class="barra_graph"></div>
											<label class="gasto_ingreso">
												<b>$<?= number_format($gasto_ingreso,2)?> </b>
												<small>(<?= number_format($porcentage,2); ?>%)</small>
											</label>
										</div>
								<? $i++; } ?>
								</div>
							<? } ?>
							<div class="col-md-6" style="min-height: 450px;">
								<?
									$max=max($maxtotales);
									$height1=(100*$total_ingresos)/$max;
									$height2=(100*$total_gastos)/$max;
								?>
								<div class="row justify-content-center align-items-center h-100">
									<div class="col-6 h-50 px-4">
										<div class="row justify-content-center align-items-end h-100" style="border-bottom: 1px solid rgba(0,0,0,0.3);">
											<div class="col-4 barra_graph_ingresos" style="height:<?= $height1; ?>%">
												<small class="fs10 text-white">$<?= number_format($total_ingresos,2);  ?></small>
											</div>
											<div class="col-2"></div>
											<div class="col-4 barra_graph_gastos" style="height:<?= $height2; ?>%">
												<small class="fs10 text-white">$<?= number_format($total_gastos,2);  ?></small>
											</div>
										</div>
									</div>
								</div>
							</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		
	</div>
</main>

<script src="https://canvasjs.com/assets/script/jquery.canvasjs.min.js"></script>
<script>

$(document).ready(function() {
	console.log('3');

	$("input.datepicker").each(function(i,e){
	    resizeInput(e);
	});

	function resizeInput(e){
		$(e).keyup(function(){
	        $(this).stop().animate({
	        	width: $(this).val().length*13
	    	},100);
	    });
	    $(e).width($(e).val().length*13);
	    $(e).val($(e).val());
	}

	var options = {
		animationEnabled: true,
		theme: "light2",
		// title:{
		// 	text: "Actual vs Projected Sales"
		// },
		axisX:{
			valueFormatString: "DD MMM"
		},
		axisY: {
			// title: "Number of Sales",
			suffix: "K",
			minimum: 30
		},
		toolTip:{
			shared:true
		},  
		legend:{
			cursor:"pointer",
			verticalAlign: "bottom",
			horizontalAlign: "left",
			dockInsidePlotArea: true,
			itemclick: toogleDataSeries
		},
		data: [{
			type: "line",
			showInLegend: true,
			name: "Ingresos",
			markerType: "circle",
			xValueFormatString: "DD MMM, YYYY",
			color: "#60AAFF",
			// yValueFormatString: "#,##0K",
			yValueFormatString: "$#,##0",
			dataPoints: [
				// { x: new Date(2022, 2, 1), y: 63 },
				<?= $pointtsIngresos; ?>
			]
		},
		{
			type: "line",
			showInLegend: true,
			name: "Gastos",
			markerType: "circle",
			// lineDashType: "dash",
			color: "#F60D4F",
			// yValueFormatString: "#,##0K",
			yValueFormatString: "$#,##0",
			dataPoints: [
				// { x: new Date(2022, 2, 1), y: 60 },
				<?= $pointtsGastos; ?>
			]
		}]
	};
	$("#chartContainer").CanvasJSChart(options);

function toogleDataSeries(e){
	if (typeof(e.dataSeries.visible) === "undefined" || e.dataSeries.visible) {
		e.dataSeries.visible = false;
	} else{
		e.dataSeries.visible = true;
	}
	e.chart.render();
}

	function getDate(e){
	   var date=$(e).datepicker({ dateFormat: 'yyyy-mm-dd' }).val();
       var months={January:'01',February:'02',March:'03',April:'04',May:'05',June:'06',July:'07',August:'08',September:'09',October:'10',November:'11',December:'12'};
       var xdate=date.split(' ');
       var date2=xdate[2]+'-'+months[xdate[1]]+'-'+xdate[0];
       return date2;
	}

	$('.datepicker').each(function(i,e){
		$(e).datepicker({
	        dateFormat: 'dd MM yy',
	        showOtherMonths: true,
	        // minDate: 0,
	        maxDate:0,
	        onSelect: function() {
		       resizeInput(e);
		       var f1=getDate('#FECHA1');
		       var f2=getDate('#FECHA2');
		       var url='<?= $_URL_; ?>?FECHA1='+f1+'&FECHA2='+f2;
		       window.location=url;
		    }
	    });

	    $
	});


});
</script>